<?php
/* $Id: publisher.php,v 1.6 2002/04/21 10:52:20 mbecker Exp $ */
function scan_for_dirs($directory){
	// read directory
	if ($dir = @opendir($directory)) {
		while ($file = readdir($dir)) {
			if (is_dir("$directory/$file") && $file != "." && $file != ".."){
				$tmpfilename[]="$directory/$file";
				$delme = scan_for_dirs ("$directory/$file");
				if (is_array($delme)){
					foreach ($delme as $element){
						$tmpfilename[]=$element;
					}
				}
			}
		}
		closedir($dir);
		return $tmpfilename;
	} else {
		return NULL;
	}
	if (!empty($tmpfilename)) {
		return $tmpfilename;
	} else {
		return (NULL);
	}
}

function scandir($directory, $filemask="*.*", $options="f"){
	// optionremarks
	// f = returns the filename only
	// d = returns the filename with relative directoryname
	// a = returns the filename with absolute directoryname
	// r = scans the dir in depth (recurse)
	// n = returns the filename without extension

	// working on filemasks
	$fmask = explode (".",$filemask);
	if ($fmask[0]=="") $fmask[0] = "*";
	if ($fmask[1]=="") $fmask[1] = "*";

	// read directory
	if ($dir = @opendir($directory)) {
		while ($file = readdir($dir)) {
			if (strchr($options,"r")) {

				if ($file != "." && $file != ".." && is_dir("$directory/$file")){
					$delme = scandir ("$directory/$file",$filemask,"fdr");

					if (is_array($delme)){
						foreach ($delme as $element){
							$tmpfilename[]=$element;
						}
					}
				}
			}
			if ($file != "." && $file != ".." && !is_dir("$directory/$file")){
				// file exists and isnt a directory
				$tmp01 = explode(".",$file);
				$tmp02 = $fmask;
				if ($tmp02[0]=="*") $tmp02[0] = $tmp01[0];
				if ($tmp02[1]=="*") $tmp02[1] = $tmp01[1];
				if ($tmp01[0] == $tmp02[0] && $tmp01[1] == $tmp02[1]){
					$ret= "";
					if (strchr($options,"d")) $ret .= "$directory/";
					if (strchr($options,"f")) $ret .= $file;
					if (strchr($options,"n")) {
						$dummy = explode (".",$ret);
						$ret = $dummy[0];
					}
					$tmpfilename[]=$ret;
					$ok=false;
				}
			}
		}
		closedir($dir);
	} else {
		return NULL;
	}
	if (!empty($tmpfilename)) {
		return $tmpfilename;
	} else {
		return (NULL);
	}
}

function readcfg ($file, $container, $property){
	global $configpath;
	if (!$configpath) $configpath = "./";
	if(!is_readable("$configpath/$file.cfg")) {
		echo "Configfile $configpath/$file.cfg not found";
		return NULL;
	}
	$caption = "none";
	$cfgfile = file("$configpath/$file.cfg");
	foreach ($cfgfile as $buffer){
		$buffer = trim($buffer);
		if (substr($buffer,-1) == "]" && substr($buffer,0,1) == "[") $caption = substr ($buffer, 1, -1);
		if (substr($buffer,0,1) != "#" && substr($buffer,0,1) != "["){
			$delme = explode("=",$buffer);
			if (trim($delme[0])=="$property" && $caption == $container){
				$element=substr (stristr ($buffer, "\""),  1, -1);
			}
		}
	}

	return ($element);
}

function mk_recurse_dir($dir){
	$dir_elements = explode ("/",$dir);
	$main_status=true;
	$current_dir = "";
	foreach ($dir_elements as $element){
		$current_dir .= $element."/";
		if (!is_dir($current_dir)){
			echo "\tcreating $current_dir";
			$status = mkdir("$current_dir",0775);
			if ($status == false){
				echo "\tfailed\n";
				$main_status=false;
			} else {
				echo "\tOK\n";
				$main_status=true;
			}
		}
	}
	return $main_status;
}

// getting system information
$cvs_bin = readcfg ("job","system","cvs_command");
echo "using $cvs_bin for checkout\n";
echo "getting config information\n";
$jobs = explode (",",readcfg ("job","global","jobs"));

echo "found following jobs:\n";
foreach ($jobs as $element){
	echo "\t$element\n";
	echo "\t\tfrom:\t".readcfg ("job","job-$element","cvsserver")."\n";
	echo "\t\tto:\t".readcfg ("job","job-$element","target")."\n";
	echo "\t\tusing:\t".readcfg ("job","job-$element","sandbox")."\n";
}
echo "processing jobs:\n";
foreach ($jobs as $element){
	echo "-- $element --------------------------------------------------------------------\n";
	// Check Sandbox
	$sandbox = readcfg ("job","job-$element","sandbox");
	$sandbox_dir = readcfg ("job","sandbox-$sandbox","path");
	$cvs_path = readcfg ("job","cvs-$sandbox","path");

	echo "checking sandbox dir ($sandbox_dir)\n";
	if (is_dir($sandbox_dir)){
		echo "\tsandbox directory found\n";
		echo "\tdeleting files in sandbox\n";
		// Delete all files in sandbox
		$filelist = scandir ("$sandbox_dir","*.*","rd");
		if (is_array($filelist)){
			foreach ($filelist as $element){
				echo "\tdeleting $element\n";
				unlink ($element);
			}
		} else {
			echo "\t no file to delete in sandbox\n";
		}
		// Delete all directorys in sandbox
		unset ($subdirs, $subdirlevel);
		$subdirs = scan_for_dirs($sandbox_dir);
		if (is_array($subdirs)){
			// Checking out the level of dirdepth
			foreach ($subdirs as $element){
				$delme = explode ("/",$element);
				if ($element != ""){
					$level["$element"] = count($delme);
				} else {
					$level["$element"] = o;
				}
				// rmdir ($element);
			}

			arsort($level);
			// Sorting subdirs by element;
			foreach ($level as $key=>$element){
				echo "\tdeleting $key level (".$element.") directory \n";
				rmdir ($key);
			}
		}
	} else {
		echo "\tcreating directory $sandbox_dir\n";
		$status = mk_recurse_dir($sandbox_dir);
		// need to fix: status is not validated yet
	}
	// Checkout the files to sandbox
	chdir ($sandbox_dir);
	// local cvs checkout
	echo "dumping result";
	echo ("$cvs_bin -d d:\cvs checkout CVSROOT");
	$delme = system("$cvs_bin -d /cvs checkout CVSROOT",$result);
}
var_dump($delme);
$dir_cache_sb = scandir ("$sandbox_dir","*.*","rd");
var_dump($dir_cache_sb);
echo "\n\nEND OF SCRIPT\n\n";
/*
$connid = ftp_connect("localhost");
echo "connid ".$connid."\n";
$result = ftp_login($connid ,"test","test");
echo "connid ".$result."\n";

$dir=ftp_pwd($connid);
echo "dir ist $dir\n";
$list=Array();

$list=ftp_rawlist($connid, "$dir");
var_dump($list);
*/
?>